/***************************************************************************
                          cdcconf.h  -  description
                             -------------------
    begin                : Wed Jul 2 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDCCONF_H
#define CDCCONF_H

#include "cconfigfile.h"
#include "cmessagedc.h"

/**dc configuration
  *@author Daniel Muller
  */

using namespace nConfig;
using std::string;
namespace nDirectConnect {

class cServerDC;

namespace nProtocol {
	class cDCProto;
};

using nProtocol::cDCProto;
using nProtocol::eDC_UNPARSED;

class cDCConf : public cConfigFile
{
public:
	cDCConf( const string &, cServerDC &);
	~cDCConf();

	friend class cServerDC;
	friend class nProtocol::cDCProto;
	friend class cDCBanList;
	friend class cDCConsole;
	friend class cConnDC;
public:
	int max_users_total;
	int max_users[3];
	int max_extra_regs;
	int max_extra_ops;
	int max_extra_admins;
	unsigned long min_share;
	unsigned long min_share_reg;
	unsigned long min_share_ops;
	unsigned long max_share;
	unsigned long max_share_reg;
	int tban_kick;
	unsigned int max_length[eDC_UNPARSED];
	unsigned max_nick;
	unsigned min_nick;
	string nick_chars;
	unsigned max_chat_msg;
	int max_chat_lines;
	int nicklist_on_login;
	int delayed_search;
	int delayed_myinfo; // implies also delayed quit, otherwise there would be a wess on hub
	string db_host;
	string db_user;
	string db_pass;
	string db_data;
	string nick_prefix;
	string hub_security;
	string opchat_name;
	string hub_name;
	string hub_desc;
	string hub_host;
	string hub_owner;
	string hublist_host;
	int hublist_port;
	/** checking prefferences */
	int check_ctm;
	int check_rctm;
	string redir_host[10];
	int hide_all_kicks;
	int optimize_userlist;
	int int_search;
	int ul_portion;

	int tag_max_hubs;
	int tag_max_slots[20];
	int tag_min_slots[20];
	double tag_max_hs_ratio;
	int tag_allow_none;
	string cc_zone1;
	string cc_zone2;
	int show_tags; // 0 - no at all; 1 - only to ops, 2- only to everyone ;)

	string msg_banned;

public: // Public attributes
  cServerDC & mS;
};

};
#endif
