/***************************************************************************
                          cdctag.h  -  description
                             -------------------
    begin                : Sun Aug 24 2003
    copyright            : (C) 2003 by Daniel Muller
    email                : dan@verliba.cz
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef CDCTAG_H
#define CDCTAG_H

#include <sstream>
#include "cpcre.h"
#include "cdcconf.h"


using namespace std;
// forward declarations
namespace nUtils { class cPCRE; };

namespace nDirectConnect
{


/**dc info tag
  *@author Daniel Muller
  */


class cDCTagParser
{
	public:
	// the constructor
	cDCTagParser();
	/** the global teg's regular expression */
	nUtils::cPCRE mTagRE;
	nUtils::cPCRE mHubsRE;
	nUtils::cPCRE mSlotsRE;
};

class cDCTag {
public:
	cDCTag(const std::string &desc, cDCConf &);
	~cDCTag();
	bool ValidateTag(ostream &os, int);

	// tag parser static - one for all
	static cDCTagParser mParser;
	cDCConf &mC;
	
	typedef enum{ eCT_NOTAG, eCT_PLUSPLUS, eCT_DCGUI, eCT_UNKNOWN } tClientType;
	typedef enum{ eCM_NOTAG, eCM_ACTIVE, eCM_PASSIVE} tClientMode;

	// tag's starting position in desc
	int mPositionInDesc;

	/** the client's type */
	tClientType mClientType;

	/** the client's mode */
	tClientMode mClientMode;
private:
	/** the tag string */
	std::string mTag;
	/** the rest of tag after the Mode until the end*/
	std::string mTagBody;

};

};
#endif
